# Copyright (c) 2022 Project CHIP Authors
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

name: Test for CASE recovery

config:
    nodeId: 0x12344321
    cluster: "Basic Information"
    endpoint: 0

tests:
    - label: "Wait for the commissioned device to be retrieved"
      cluster: "DelayCommands"
      command: "WaitForCommissionee"
      arguments:
          values:
              - name: "nodeId"
                value: nodeId

    # Make sure we have a working CASE session.
    - label: "Read an attribute"
      command: "readAttribute"
      attribute: "DataModelRevision"
      response:
          constraints:
              type: int16u
              minValue: 17

    - label: "Reboot the server"
      cluster: "SystemCommands"
      command: "Reboot"

    - label: "Re-get our session, but without expiring sesssions"
      cluster: "DelayCommands"
      command: "WaitForCommissionee"
      arguments:
          values:
              - name: "nodeId"
                value: nodeId
              - name: "expireExistingSession"
                value: false

    # Try to do something with the CASE session.  This should time out, but
    # mark the CASE session as defunct.
    - label: "Read an attribute again"
      command: "readAttribute"
      attribute: "DataModelRevision"
      response:
          error: FAILURE

    - label: "Re-get our session, but without expiring sesssions"
      cluster: "DelayCommands"
      command: "WaitForCommissionee"
      arguments:
          values:
              - name: "nodeId"
                value: nodeId
              - name: "expireExistingSession"
                value: false

    # Now trying to do another read should create a new CASE session successfully.
    - label: "Read an attribute a third time"
      command: "readAttribute"
      attribute: "DataModelRevision"
      response:
          constraints:
              type: int16u
              minValue: 17
